package com.fp.frontend.controller.bpm;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import javax.faces.context.FacesContext;
import javax.servlet.http.HttpServletRequest;

import org.primefaces.event.SelectEvent;

import com.fp.dto.AbstractDataTransport;
import com.fp.dto.Request;
import com.fp.dto.Response;
import com.fp.dto.query.DtoQuery;
import com.fp.dto.query.SubQuery;
import com.fp.dto.save.DtoSave;
import com.fp.frontend.controller.AbstractController;
import com.fp.frontend.controller.pgeneral.lov.MessageTemplatesLovController;
import com.fp.frontend.helper.MessageHelper;
import com.fp.persistence.pbpm.gene.TbpmRules;
import com.fp.persistence.pgeneral.message.TgeneMessageTemplates;

/**
 * Clase controladora del bean TbpmRules.
 *
 * @author WPA
 * @version 2.1
 */
@ManagedBean
@ViewScoped
public class RulesController extends AbstractController<TbpmRules> {

    private static final long serialVersionUID = 1L;

    public RulesController() throws Exception {
        super(TbpmRules.class);
    }

    /**
     * Atributo para el tipo de archivo
     */
    private List<String[]> lfiletype;
    /**
     * Atributo para Si/No
     */
    private List<String[]> lyesnot;

    @PostConstruct
    private void postconstruct() {
        this.init();
        // Inicializa autoconsulta
        super.startQuery();
        //Listas
        this.getListFileType();
        this.getList();
    }

    /**
     * Incializa el controlador, cuando se esta utilizando una pagina que utliza
     * el controlador.
     */
    private void init() {
        try {
            this.recperpage = 10; // Cambiar al # reg a mirar.
            this.lrecord = new ArrayList<>();
            this.beanalias = "TBPMRULES";
        } catch (Exception e) {
            MessageHelper.setMessageError(e);
        }
    }

    @SuppressWarnings("unchecked")
    @Override
    protected void querydatabase() {
        try {

            super.addFilter("pk.companycode", super.getLoginController().getRequest().getCompany().toString());

            Request request = this.callerhelper.getRequest();
            DtoQuery dto = super.getDtoQuery(true);
            dto.setOrderby("t.pk.rulecode");

            //Subquery
            SubQuery subquery = new SubQuery("TgeneMessageTemplates", "description", "messagedesc", "i.pk = t.messagecode");
            dto.addSubQuery(subquery);

            HashMap<String, DtoQuery> mtables = new HashMap<String, DtoQuery>();
            mtables.put(this.beanalias, dto); // permite adicionar mas de una tabla.

            request.setQueryTables(mtables);

            Response resp = this.callerhelper.executeQuery(request);

            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) != 0) {
                this.lrecord = new ArrayList<TbpmRules>();
                MessageHelper.setMessageError(resp);
            } else {
                this.lrecord = (List<TbpmRules>) resp.get(this.beanalias);
                super.postQuery(this.lrecord);
            }

        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    @Override
    public void save() {
        try {
            Request request = this.callerhelper.getRequest();
            DtoSave dtosave = super.getDtoSave();
            if (!dtosave.pendingProcess()) {
                return;
            }
            HashMap<String, DtoSave> msave = new HashMap<String, DtoSave>();
            msave.put(this.beanalias, dtosave); // adicionar metadata de mantenimiento para cada tabla.

            request.setSaveTables(msave);
            Response resp = this.callerhelper.executeSave(request);
            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) == 0) {
                this.postCommit(resp);
                MessageHelper.setMessageInfo(resp);
            } else {
                MessageHelper.setMessageError(resp);
            }

        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    public void refresh() {
        try {
            Request request = this.callerhelper.getRequest();
            DtoSave dtosave = new DtoSave();
            List<AbstractDataTransport> l = new ArrayList<AbstractDataTransport>();
            l.add(this.record);
            dtosave.addNew(l);
            HashMap<String, DtoSave> msave = new HashMap<String, DtoSave>();
            msave.put(this.beanalias, dtosave); // adicionar metadata de mantenimiento para cada tabla.

            request.setSaveTables(msave);
            request.modifiedData().put("refresh", "Y");
            Response resp = this.callerhelper.executeSave(request);
            request.modifiedData().remove("refresh");
            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) == 0) {
                MessageHelper.setMessageInfo(resp);
            } else {
                MessageHelper.setMessageError(resp);
            }

        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    @Override
    public void create() throws Exception {
        super.create();
        this.record.getPk().setCompanycode(super.getLoginController().getRequest().getCompany());
        this.record.setSnapshot("LATEST");
        this.record.setParametertype("java.util.Map");
    }

    /**
     * Metodo que llena lal lista de tipo de archivo
     */
    private void getListFileType() {
        this.lfiletype = new ArrayList<String[]>();
        String[] flows = {"F", "FLUJOS"};
        String[] rules = {"R", "REGLAS"};
        this.lfiletype.add(flows);
        this.lfiletype.add(rules);
    }

    /**
     * Metodo que llena lal lista de tipo de archivo
     */
    private void getList() {
        this.lyesnot = new ArrayList<String[]>();
        String[] no = {"N", "NO"};
        String[] yes = {"Y", "SI"};
        this.lyesnot.add(no);
        this.lyesnot.add(yes);
    }

    /**
     * Abre el Lov de Mensajes
     */
    public void openMessagesLov() {
        Map<String, List<String>> params = new HashMap<>();
        MessageTemplatesLovController.openLov(params);
    }

    /**
     * Gestiona la respuesta del lov
     *
     * @param event
     * @throws Exception
     */
    public void onReturnMessagesLov(SelectEvent event) throws Exception {
        TgeneMessageTemplates t = (TgeneMessageTemplates) event.getObject();
        this.record.setMessagecode(t.getPk());
        this.record.getModifiedData().put("messagedesc", t.getDescription());
    }

    /**
     * Entrega la lista de tpos de archivo
     *
     * @return lfiletype Lista de tpos de archivo
     */
    public List<String[]> getLfiletype() {
        return lfiletype;
    }

    /**
     * Fija la lista de tpos de archivo
     *
     * @param lfiletype Lista de tpos de archivo
     */
    public void setLfiletype(List<String[]> lfiletype) {
        this.lfiletype = lfiletype;
    }

    /**
     * Entrega la lista Si/No
     *
     * @return lyesnot Lista Si/No
     */
    public List<String[]> getLyesnot() {
        return lyesnot;
    }

    /**
     * Fija la lista Si/No
     *
     * @param lyesnot Lista Si/No
     */
    public void setLyesnot(List<String[]> lyesnot) {
        this.lyesnot = lyesnot;
    }

    /**
     * Elimina el mensaje
     */
    public void removemessage() {
        if (this.record != null) {
            this.record.setMessagecode(null);
            this.record.put("messagedesc", null);
        }
    }

    /**
     * Fija el paquete segun el tipo de archivo
     */
    public void changeFile() {
        if (this.record.getFiletype().equals("F")) {
            this.record.setPackagename("maia.flows");
        } else if (this.record.getFiletype().equals("R")) {
            this.record.setPackagename("maia.rules");
        } else {
            this.record.setPackagename(null);
        }
    }
}
